﻿Imports System.Runtime.CompilerServices
Imports System.Diagnostics
Imports System.Runtime.InteropServices

Namespace System

   Public Module ByteArrayX
      ''' <summary>note: to convert primitive data better use BitConverter</summary>
      <Extension()> _
      Public Sub ReadTo(Of T)(ByVal Subj As Byte(), ByVal Offs As Integer, ByVal Targets As T())
         Dim size = Marshal.SizeOf(GetType(T))
         Buffer.BlockCopy(Subj, Offs, Targets, 0, Targets.Length * size)
      End Sub

      ''' <summary>note: to convert primitive data better use BitConverter</summary>
      <Extension()> _
      Public Function Read(Of T)(ByVal Subj As Byte(), ByVal Offs As Integer) As T
         Dim size = Marshal.SizeOf(GetType(T))
         Dim Targets(0) As T
         Buffer.BlockCopy(Subj, Offs * size, Targets, 0, size)
         Return Targets(0)
      End Function

   End Module
End Namespace
