﻿Imports System.Runtime.CompilerServices

Namespace System

   Public Module MiscX

      <Extension()> _
      Public Sub [Xor](ByRef Subj As Integer, ByVal Value As Integer)
         Subj = Subj Xor Value
      End Sub
      <Extension()> _
      Public Function Abs(ByVal Subj As Integer) As Integer
         Return If(Subj < 0, -Subj, Subj)
      End Function
      <Extension()> _
      Public Function TryParseX(ByRef Subj As Integer, ByVal s As String) As Boolean
         Return Integer.TryParse(s, Subj)
      End Function
      <Extension()> _
      Public Function TryParseX(ByRef Subj As Decimal, ByVal s As String) As Boolean
         Return Decimal.TryParse(s, Subj)
      End Function
      <Extension()> _
      Public Function TryParseX(ByRef Subj As Double, ByVal s As String) As Boolean
         Return Double.TryParse(s, Subj)
      End Function
      <Extension()> _
      Public Function TryParseX(ByRef Subj As Single, ByVal s As String) As Boolean
         Return Single.TryParse(s, Subj)
      End Function
      <Extension()> _
      Public Function TryParseX(ByRef Subj As Date, ByVal s As String) As Boolean
         Return Date.TryParse(s, Subj)
      End Function

   End Module

End Namespace