﻿Imports System.IO

Public Class TextReaderEnumerable : Inherits Enumerable(Of String)

   Private _Reader As TextReader
   Public Sub New(ByVal Reader As TextReader)
      _Reader = Reader
   End Sub

   Private _Current As String = Nothing

   Protected Overrides Sub Prepare()
      MyBase.Prepare()
      _Current = _Reader.ReadLine
   End Sub

   Protected Overrides Function TryMovenext(ByRef Current As String) As Boolean
      If _Current.Null Then Return False
      Current = _Current
      _Current = _Reader.ReadLine
      Return True
   End Function
End Class
