﻿Imports System.Runtime.CompilerServices

Namespace Helpers.BitOperation

   Public Module BitOperationX


      <Extension()> _
      Public Sub SetFlag(Of T)(ByRef Subj As T, ByVal Value As T, Optional ByVal [on] As Boolean = True)
         If [on] Then
            Subj = DirectCast(DirectCast(DirectCast(DirectCast(Subj, Object), Integer) Or DirectCast(DirectCast(Value, Object), Integer), Object), T)
         Else
            Subj = DirectCast(DirectCast(DirectCast(DirectCast(Subj, Object), Integer) Or Not DirectCast(DirectCast(Value, Object), Integer), Object), T)
         End If
      End Sub

      '<Extension()> _
      'Public Sub SetFlag(Of T)(ByRef Subj As T, ByVal Value As Integer, Optional ByVal [on] As Boolean = True)
      '   If [on] Then
      '      Subj = DirectCast(DirectCast(DirectCast(DirectCast(Subj, Object), Integer) Or Value, Object), T)
      '   Else
      '      Subj = DirectCast(DirectCast(DirectCast(DirectCast(Subj, Object), Integer) Or Not Value, Object), T)
      '   End If
      'End Sub

      <Extension()> _
      Public Sub [And](ByRef Subj As Integer, ByVal Value As Integer)
         Subj = Subj And Value
      End Sub
      <Extension()> _
      Public Sub [Xor](ByRef Subj As Integer, ByVal Value As Integer)
         Subj = Subj Xor Value
      End Sub
      <Extension()> _
      Public Sub [Or](ByRef Subj As Integer, ByVal Value As Integer)
         Subj = Subj Or Value
      End Sub

   End Module

End Namespace
