﻿Imports System.ComponentModel
Imports System.Text

Partial Class GrKassDts

   Partial Class PostenDataTable
      Private Shared _DeletedParent As BelegRow 'muß nach! dem Deleten eines Postens neu berechnet wern

      Public Sub Column_Changing(ByVal sender As Object, ByVal e As DataColumnChangeEventArgs)
         'ggfs ProposedValue nachbessern
         With DirectCast(e.Row, PostenRow)
            Select Case True
               Case e.Column Is columnEigentum
                  If Not .Eigentum AndAlso .KasseRow.RejectsOwnership Then e.ProposedValue = False
               Case e.Column Is columnVorgang
                  Me.Dts.AutoVorgang.ProposeValue(e)
            End Select
         End With
      End Sub

      Public Sub Column_Changed(ByVal sender As Object, ByVal e As DataColumnChangeEventArgs)
         If e.Column IsNot columnBetrag OrElse e.Row.RowState = DataRowState.Detached Then Return
         e.Row.CastX(Of PostenRow).BelegRow.Recalculate()
      End Sub

      Public Sub Row_Changed(ByVal sender As Object, ByVal e As PostenRowChangeEvent)
         If e.Action = DataRowAction.Add Then e.Row.CastX(Of PostenRow).BelegRow.Recalculate()
      End Sub

      Private Sub PostenDataTable_PostenRowDeleting(ByVal sender As Object, ByVal e As PostenRowChangeEvent) Handles Me.PostenRowDeleting
         _DeletedParent = e.Row.BelegRow
      End Sub
      Public Sub Row_Deleted(ByVal sender As Object, ByVal e As PostenRowChangeEvent)
         _DeletedParent.Recalculate()
         _DeletedParent = Nothing
      End Sub

      Private Sub PostenDataTable_TableNewRow(ByVal sender As Object, ByVal e As DataTableNewRowEventArgs) Handles Me.TableNewRow
         'das Datum der zuletzt geaddeten row als DefaultValue, eigenes AutoIncrement mit weniger Lücken
         Dim rw = DirectCast(e.Row, PostenRow)
         With Me.DefaultView
            For i = .Count - 1 To 0 Step -1
               Dim last = .At(Of PostenRow)(i)
               If last.Vorgang.HasValue Then
                  rw.Vorgang = last.Vorgang
                  rw.KasseID = last.KasseID
                  Return
               End If
            Next
            rw.Vorgang = "<Vorgang>"
            Dim k = Me.Dts.Kasse.FirstOrDefault(Function(ks) Not ks.RejectsOwnership)
            If k.NotNull Then rw.KasseID = k.KasseID
         End With
      End Sub
   End Class

End Class
