﻿Imports System.ComponentModel

Public Class frmStueck : Implements INotifyPropertyChanged
   Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

   Private _Value As Decimal

   Public Sub New()
      InitializeComponent()
      Left = Screen.PrimaryScreen.WorkingArea.Right - Width
      With StueckDts.Stueck
         If .Rows.Count = 0 Then
            Dim fact = 0.01D
            For i = 1 To 5
               .AddStueckRow(fact, 0)
               .AddStueckRow(2 * fact, 0)
               .AddStueckRow(5 * fact, 0)
               fact *= 10
            Next
         End If
      End With
      ControlBehavior.InitGrids(Me)
      With DataGridView1
         AddHandler .CellPainting, ControlBehavior.GridHideZeroNegativeRed_CellPainting
         'Dim x = .GetCellDisplayRectangle(0, .RowCount - 1, False)
         '.Height = .GetCellDisplayRectangle(0, .RowCount - 1, False).Bottom
      End With
   End Sub

   Public ReadOnly Property Value As Decimal
      Get
         Return _Value
      End Get
   End Property

   Private Sub StueckBindingSource_ListChanged(ByVal sender As Object, ByVal e As ListChangedEventArgs) Handles StueckBindingSource.ListChanged, SonstBindingSource.ListChanged
      _Value = StueckDts.Stueck.All.Sum(Function(rw) rw.Wert)
      _Value += StueckDts.Sonst.All.Sum(Function(rw) rw.Wert)
      Label1.Text = _Value.ToString("n2")
      RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Value"))
   End Sub

   Private Sub frmStueck_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
      With DataGridView1
         .Height = .RowCount * .RowTemplate.Height
      End With
   End Sub
End Class
