﻿Imports GrKass.GrKassDts
Imports System.Text

Public Class frmUser

   Protected Overrides Sub Dispose(ByVal disposing As Boolean)
      MyBase.Dispose(disposing)
      If disposing AndAlso components IsNot Nothing Then components.Dispose()
   End Sub

   Private Sub frmUser_Load(ByVal sender As Object, ByVal le As EventArgs) Handles MyBase.Load
      Me.StartUpAt(ContentAlignment.TopCenter)
      Dim user = UclBillInput1.BetreuerBindingSource.At(Of BetreuerRow)()
      Dim settings = Program.Dts.Settings(0)
      Me.Text = "Gruppenkasse ".And(settings.GruppeName, " - ", user.BetreuerName)
      With UclAllBills1.PostenSource
         ' UclBillInput (=Belegeingabe) synchronisiert sich nach der PostenSource von AlleBelege
         AddHandler .CurrentChanged, AddressOf UclBillInput1.Synchronisize
      End With
      UclAllBills1.SetBetreuer(user.BetreuerID)
      ControlBehavior.ActivateLockInfoMenu(btLockInfo)
      btLockInfo.Visible = settings.Locked
      SaveToolStripMenuItem.Enabled = Not settings.Locked
      Dim hst = New ToolStripControlHost(UclBillInput1.cpKultur) With {.Margin = New Padding(30, 0, 0, 0)}
      MenuStrip1.Items.Add(hst)
   End Sub

   Private Sub MenuStrip_MenuClicked(ByVal Sender As Object, ByVal e As EventArgs) _
         Handles ReLoadToolStripMenuItem.Click, SaveToolStripMenuItem.Click, ZählhilfeToolStripMenuItem.Click, HilfeToolStripMenuItem.Click, AutoVorgangToolStripMenuItem.Click
      Select Case True
         Case Sender Is ReLoadToolStripMenuItem
            DataPersistance.LoadData()

         Case Sender Is SaveToolStripMenuItem
            Program.DataSetSaver.SaveForm(Me)

         Case Sender Is ZählhilfeToolStripMenuItem
            Dim f = frmStueck
            If f.Visible Then f.BringToFront() Else f.Show(Me)

         Case Sender Is HilfeToolStripMenuItem
            Process.Start("..\..\Other\Hilfe.rtf")

         Case Sender Is AutoVorgangToolStripMenuItem
            frmAutoVorgang.AutoVorgangDataGridView.DataSource = Program.Dts.AutoVorgang
            frmAutoVorgang.Show(Me)

      End Select
   End Sub
End Class